## corsix-th 0.68.0

=== CMakeLists.txt ===
# Cmake File for CorsixTH
# OPTIONS AVAILABLE:
# Any of the following: (default)
#   - WITH_AUDIO      : Activate sound (yes)
#   - WITH_FREETYPE2  : Active support for non-Latin script alphabets (yes)
#   - WITH_MOVIES     : Activate movies (requires with_audio, FFmpeg) (yes)
#   - WITH_LUAJIT     : Use LuaJIT instead of Lua (must specify library path) (no)
#   - WITH_UPDATE_CHECK : Activates support to check for new version on launch (requires libcurl) (yes)
#   - USE_SOURCE_DATADIRS : Use the source directory for loading resources. Incompatible with the install target (no)
#   - SEARCH_LOCAL_DATADIRS : Search resources in the working directory and the
#       program directory where the executable stores. Makes the executable
#       portable (yes for Apple)

#   - WITH_VLD        : Build with Visual Leak Detector (requires Visual Studio) (no)
#   - USE_PRECOMPILED_DEPS : Use precompiled dependencies on *nix (no)
#   - WITH_LUAROCKS : Install required luarocks in the macOS app (requires luarocks)

#   - ENABLE_UNIT_TESTS : Enable Unit Testing Target (requires Catch2) (no)
#   - BUILD_ANIMVIEW : Generate AnimView build files (no)
#   - BUILD_TOOLS : Generate cli tools

cmake_minimum_required(VERSION 3.14)

# Define our options
option(BUILD_CORSIXTH "Builds the main game" ON)
option(WITH_AUDIO "Activate sound" ON)
option(WITH_FREETYPE2 "Enhanced font support" ON)
option(WITH_MOVIES "Activate in game movies" ON)
option(WITH_LUAJIT "Use LuaJIT instead of Lua" OFF)
option(WITH_UPDATE_CHECK "Check for new versions" ON)
option(USE_SOURCE_DATADIRS "Use the source directory for loading resources. Incompatible with the install target" OFF)
option(ENABLE_UNIT_TESTS "Enables Unit Testing Targets" OFF)
option(BUILD_ANIMVIEW "Build the animation viewer as part of the build process" OFF)
option(BUILD_TOOLS "Build additional CLI tools (rnc_decode)" OFF)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake)

if(WITH_FREETYPE2)
  list(APPEND VCPKG_MANIFEST_FEATURES "freetype")
endif()
if(WITH_AUDIO)
  list(APPEND VCPKG_MANIFEST_FEATURES "audio")
  if(WITH_MOVIES)
    list(APPEND VCPKG_MANIFEST_FEATURES "movies")
  endif()
endif()
if(BUILD_ANIMVIEW)
  list(APPEND VCPKG_MANIFEST_FEATURES "animview")
endif()
if(WITH_UPDATE_CHECK)
  list(APPEND VCPKG_MANIFEST_FEATURES "updatecheck")
endif()
if(ENABLE_UNIT_TESTS)
  list(APPEND VCPKG_MANIFEST_FEATURES "catch2")
endif()

project(CorsixTH_Top_Level)

if(MINGW)
  set(CMAKE_EXE_LINKER_FLAGS "-static-libgcc -static-libstdc++")
endif()

include(CheckIncludeFiles)

set(CORSIX_TH_DONE_TOP_LEVEL_CMAKE ON)

if(APPLE)
  set(SEARCH_LOCAL_DATADIRS_DEFAULT ON)
else()
  set(SEARCH_LOCAL_DATADIRS_DEFAULT OFF)
endif()

option(SEARCH_LOCAL_DATADIRS
  "Search resources in the working directory and the program directory where the executable stores."
  ${SEARCH_LOCAL_DATADIRS_DEFAULT})

if(MSVC)
  option(WITH_VLD "Build with Visual Leak Detector for Visual Studio" OFF)
endif()
# Dependency management
if(UNIX AND CMAKE_COMPILER_IS_GNU)
  option(USE_PRECOMPILED_DEPS "Use Precompiled Dependencies" OFF) # Make *nix systems opt in
endif()

if(APPLE)
  option(WITH_LUAROCKS "Install required luarocks in the app" OFF)
endif()

if(WITH_AUDIO)
  set(CORSIX_TH_USE_SDL_MIXER ON)
  message("Note: SDL audio is enabled (default)")
else()
  set(CORSIX_TH_USE_SDL_MIXER OFF)
  message("Note: SDL audio is disabled")
endif()

if(WITH_MOVIES)
  if(WITH_AUDIO)
    set(CORSIX_TH_USE_FFMPEG ON)
    message("Note: FFmpeg video is enabled (default)")
  else()
    set(CORSIX_TH_USE_FFMPEG OFF)
    message("Note: FFmpeg video disabled since it requires SDL audio.")
  endif()
else()
  set(CORSIX_TH_USE_FFMPEG OFF)
  message("Note: FFmpeg video is disabled")
endif()

if(WITH_FREETYPE2)
  set(CORSIX_TH_USE_FREETYPE2 ON)
  message("Note: FreeType2 is enabled (default)")
else()
  set(CORSIX_TH_USE_FREETYPE2 OFF)
  message("Note: FreeType2 is disabled")
endif()

if(WITH_UPDATE_CHECK)
  message("Note: Update check is enabled (default)")
else()
  message("Note: Update check is disabled")
endif()

if(VCPKG_TARGET_TRIPLET AND NOT WITH_LUAROCKS)
  set(CORSIX_TH_LINK_LUA_MODULES ON)
else()
  set(CORSIX_TH_LINK_LUA_MODULES OFF)
endif()

if(MSVC)
  if(WITH_VLD)
    set(CORSIX_TH_USE_VLD ON)
    message("Note: Visual Leak Detector is enabled")
  else()
    set(CORSIX_TH_USE_VLD OFF)
    message("Note: Visual Leak Detector is disabled (default)")
  endif()
else()
  set(CORSIX_TH_USE_VLD OFF)
endif()

# Get precompiled dependencies before running the various find modules
if(USE_PRECOMPILED_DEPS)
  message("Note: Using precompiled dependencies.")
  include(PrecompiledDeps)
endif()

include(GNUInstallDirs)

# Include individual projects
message("")

message("Building common libraries")
add_subdirectory("libs")

# We build CorsixTH if BUILD_CORSIXTH is set. This is set by default and should generally be set.
if(BUILD_CORSIXTH)
  message("Building CorsixTH")
  add_subdirectory(CorsixTH)
  set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT CorsixTH)
endif()

if(BUILD_ANIMVIEW)
  message("Building AnimView")
  add_subdirectory(AnimView)
endif()

if(BUILD_TOOLS)
  message("Building Tools")
  add_subdirectory("tools")
endif()

message("")

# Documentation generation, construct 'doc' target
include(GenerateDoc)

=== AnimView/CMakeLists.txt ===
# Sanity check
if(CORSIX_TH_DONE_TOP_LEVEL_CMAKE)
else()
  message(FATAL_ERROR "Please run CMake from the top-level directory instead of here.")
endif()

# Project Declaration
project(AnimView)

configure_file(config.h.in config.h)

# Generate source files list
# Note: do not use generic includes (*.cpp and such) this will break things with cmake
set(animview_source_files
  ${CMAKE_CURRENT_BINARY_DIR}/config.h

  app.cpp
  frmMain.cpp
  frmSprites.cpp
  th.cpp

  app.h
  backdrop.h
  frmMain.h
  frmSprites.h
  th.h

  AnimView.rc
)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# Declaration of the executable
if(APPLE)
  set(corsixth_icon_file ${CMAKE_SOURCE_DIR}/AnimView/Icon.icns)
  set_source_files_properties(
    ${corsixth_icon_file}
    PROPERTIES
    MACOSX_PACKAGE_LOCATION Resources
  )
  set(MACOSX_BUNDLE_ICON_FILE Icon.icns)

  add_executable(
    AnimView
    MACOSX_BUNDLE
    ${animview_source_files}
    ${corsixth_icon_file}
  )

  set_target_properties(AnimView PROPERTIES LINK_FLAGS_MINSIZEREL "-dead_strip")
  set_target_properties(AnimView PROPERTIES XCODE_ATTRIBUTE_LD_RUNPATH_SEARCH_PATHS "@executable_path/../Frameworks")
else()
  add_executable(
    AnimView
    WIN32 # This prevents the dos console showing up
    ${animview_source_files}
  )
endif()

target_link_libraries(AnimView RncLib)

# Set language standard
set_property(TARGET AnimView PROPERTY CXX_STANDARD 14)
set_property(TARGET AnimView PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET AnimView PROPERTY CXX_STANDARD_REQUIRED ON)

## Finding libraries

# Find WxWidgets
set(wxWidgets_USE_LIBS core base) # optionally: more than wx std libs
find_package(wxWidgets REQUIRED)
if(wxWidgets_FOUND)
  link_libraries(${wxWidgets_LIBRARIES})
  include_directories(${wxWidgets_INCLUDE_DIRS})
  include(${wxWidgets_USE_FILE})
  target_link_libraries(AnimView ${wxWidgets_LIBRARIES})
  message("  wxWidgets found")
else()
  message(FATAL_ERROR "error: wxWidgets library not found, it is required to build")
  message("Make sure the path is correctly defined or set the environment variable WXWIN to the correct location")
endif()

if(MSVC)
  # We want to bind against the very latest versions of the MSVC runtimes
  add_definitions(/D "_BIND_TO_CURRENT_VCLIBS_VERSION=1")
endif()

if(APPLE)
  install(TARGETS AnimView BUNDLE DESTINATION .)

  # Fix the macOS bundle to include required libraries (create a redistributable app)
  install(CODE "
    INCLUDE(BundleUtilities)
    SET(BU_CHMOD_BUNDLE_ITEMS ON)
    FIXUP_BUNDLE(\"${CMAKE_INSTALL_PREFIX}/AnimView.app\" \"\" \"\")
    ")
else()
  install(TARGETS AnimView RUNTIME DESTINATION AnimView)
  install(FILES ../LICENSE.txt DESTINATION AnimView)
endif()

set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT AnimView)

=== CorsixTH/CMakeLists.txt ===
# Sanity check
if(CORSIX_TH_DONE_TOP_LEVEL_CMAKE)
else()
  message(FATAL_ERROR "Please run CMake from the top-level directory instead of here.")
endif()

# Project Declaration
project(CorsixTH)

if(MSVC)
  # We want to bind against the very latest versions of the MSVC runtimes
  add_definitions(/D "_BIND_TO_CURRENT_VCLIBS_VERSION=1")
  # Suppress warnings about insecure functions
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

set(CORSIX_TH_SEARCH_LOCAL_DATADIRS ${SEARCH_LOCAL_DATADIRS})

set(CORSIX_TH_INTERPRETER_NAME CorsixTH.lua)
if(USE_SOURCE_DATADIRS)
  set(CORSIX_TH_DATADIR ${CMAKE_CURRENT_SOURCE_DIR})
  set(CORSIX_TH_INTERPRETER_PATH ${CORSIX_TH_DATADIR}/${CORSIX_TH_INTERPRETER_NAME})
elseif(MSVC)
  set(CORSIX_TH_DATADIR CorsixTH)
  set(CORSIX_TH_INTERPRETER_PATH ${CORSIX_TH_INTERPRETER_NAME})
elseif(APPLE)
  set(CORSIX_TH_DATADIR CorsixTH.app/Contents/Resources/)
  set(CORSIX_TH_INTERPRETER_PATH ${CMAKE_INSTALL_PREFIX}/${CORSIX_TH_DATADIR}/${CORSIX_TH_INTERPRETER_NAME})
else()
  set(CORSIX_TH_DATADIR ${CMAKE_INSTALL_DATADIR}/corsix-th)
  set(CORSIX_TH_INTERPRETER_PATH ${CMAKE_INSTALL_FULL_DATADIR}/corsix-th/${CORSIX_TH_INTERPRETER_NAME})
endif()

# Declaration of the executable
if(APPLE)
  set(corsixth_icon_file ${CMAKE_SOURCE_DIR}/CorsixTH/Icon.icns)
  set_source_files_properties(
    ${corsixth_icon_file}
    PROPERTIES
    MACOSX_PACKAGE_LOCATION Resources
  )
  set(MACOSX_BUNDLE_ICON_FILE Icon.icns)

  add_executable(CorsixTH MACOSX_BUNDLE ${corsixth_icon_file})

  set_target_properties(CorsixTH PROPERTIES LINK_FLAGS_MINSIZEREL "-dead_strip")
  set_target_properties(CorsixTH PROPERTIES XCODE_ATTRIBUTE_LD_RUNPATH_SEARCH_PATHS "@executable_path/../Frameworks")
elseif(MSVC)
  add_executable(CorsixTH CorsixTH.rc)
else()
  add_executable(CorsixTH "")
endif()

# Report operating system in compile_opts.os
if(WIN32)
  set(CORSIX_TH_OS "windows")
elseif(APPLE)
  set(CORSIX_TH_OS "macos")
else()
  set(CORSIX_TH_OS "unix")
endif()

# Report system architecture in compile_opts.arch
if(MSVC)
  set(CORSIX_TH_ARCH ${CMAKE_CXX_COMPILER_ARCHITECTURE_ID})
else()
  set(CORSIX_TH_ARCH ${CMAKE_SYSTEM_PROCESSOR})
endif()

# Ensure config.h is picked up by cmake - moving this into subdir cmake files will
# prevent it applying to the CorsixTH project
set(CorsixTH_generated_src_dir ${CMAKE_BINARY_DIR}/CorsixTH/Src/)
add_library(CorsixTH_lib STATIC ${CorsixTH_generated_src_dir})

target_include_directories(CorsixTH_lib PUBLIC ${CorsixTH_generated_src_dir})

target_link_libraries(CorsixTH_lib PRIVATE RncLib)
if(SEARCH_LOCAL_DATADIRS)
  target_link_libraries(CorsixTH_lib PRIVATE WhereamiLib)
endif()
target_link_libraries(CorsixTH PRIVATE CorsixTH_lib)

if(UNIX AND NOT APPLE)
  set_target_properties(CorsixTH PROPERTIES OUTPUT_NAME corsix-th)
endif()

# Generate source files list
# Note: Done after generating targets
add_subdirectory(${PROJECT_SOURCE_DIR}/Src)
add_subdirectory(${PROJECT_SOURCE_DIR}/SrcUnshared)

# Set language standard
set_property(TARGET CorsixTH_lib PROPERTY CXX_STANDARD 14)
set_property(TARGET CorsixTH_lib PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET CorsixTH_lib PROPERTY CXX_STANDARD_REQUIRED ON)

set_property(TARGET CorsixTH PROPERTY CXX_STANDARD 14)
set_property(TARGET CorsixTH PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET CorsixTH PROPERTY CXX_STANDARD_REQUIRED ON)

## Finding libraries

# Find SDL
if(VCPKG_TARGET_TRIPLET)
  find_package(SDL2 CONFIG REQUIRED)
  target_link_libraries(CorsixTH_lib
    PUBLIC
      $<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>)
  target_link_libraries(CorsixTH PRIVATE SDL2::SDL2main)
else()
  find_package(SDL2 REQUIRED)
  if(SDL_FOUND)
    include_directories(${SDL_INCLUDE_DIR})
    if(SDLMAIN_LIBRARY STREQUAL "")
      message(FATAL_ERROR "Error: SDL2 was found but SDL2main was not")
      message("Make sure the path is correctly defined or set the environment variable SDLDIR to the correct location")
    endif()
    # No need to specify sdl2main separately, the FindSDL.cmake file will take care of that. If not we get an error about it
    target_link_libraries(CorsixTH PRIVATE ${SDL_LIBRARY})
    message("  SDL2 found")
  else()
    message(FATAL_ERROR "Error: SDL2 library not found, it is required to build. Make sure the path is correctly defined or set the environment variable SDLDIR to the correct location")
  endif()
endif()

# Find Lua
if(VCPKG_TARGET_TRIPLET)
  find_package(Lua CONFIG REQUIRED)
  target_link_libraries(CorsixTH_lib PUBLIC lua)
  target_link_libraries(CorsixTH PRIVATE lua)
else()
  find_package(Lua REQUIRED)
  if(Lua_FOUND OR LUA_FOUND)
    target_link_libraries(CorsixTH PUBLIC ${LUA_LIBRARY})
    include_directories(${LUA_INCLUDE_DIR})
    # Special link flags needed on macOS 64bit, according to: http://luajit.org/install.html
    # If these are not specified, luaL_newstate() returns NULL and we get this:
    #   Fatal error starting CorsixTH: Cannot open Lua state.
    if(APPLE AND LUA_LIBRARIES MATCHES "libluajit" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
      target_link_libraries(CorsixTH "-pagezero_size 10000" "-image_base 100000000")
    endif()
    if(LUA_LIBRARIES MATCHES "libluajit")
      message("  LuaJIT${LUA_VERSION_MAJOR}.${LUA_VERSION_MINOR} found")
    else()
      message("  Lua${LUA_VERSION_MAJOR}.${LUA_VERSION_MINOR} found")
      if(WITH_LUAJIT)
        message("    Did you want to use LuaJIT? Please specify the path")
      endif()
      unset(WITH_LUAJIT CACHE)
    endif()
  else()
    message(FATAL_ERROR "Error: Lua library not found, it is required to build")
  endif()
endif()

# Add threading library
find_package(Threads)
target_link_libraries(CorsixTH PRIVATE ${CMAKE_THREAD_LIBS_INIT})

# Find SDL_mixer
if(CORSIX_TH_USE_SDL_MIXER)
  if(VCPKG_TARGET_TRIPLET)
    find_package(SDL2_mixer CONFIG REQUIRED)
    target_link_libraries(
      CorsixTH
      PRIVATE
        $<IF:$<TARGET_EXISTS:SDL2_mixer::SDL2_mixer>,SDL2_mixer::SDL2_mixer,SDL2_mixer::SDL2_mixer-static>)
  else()
    find_package(SDL2_mixer REQUIRED)
    if(SDLMIXER_FOUND)
      target_link_libraries(CorsixTH PRIVATE ${SDLMIXER_LIBRARY})
      include_directories(${SDLMIXER_INCLUDE_DIR})
      message("  SDL_mixer found")
    else()
      message(FATAL_ERROR "Error: SDL_mixer library not found, even though it was selected to be included")
    endif()
  endif()
endif()

# Find FFMPEG
if(CORSIX_TH_USE_FFMPEG)
  find_package(FFmpeg COMPONENTS AVFORMAT AVCODEC AVUTIL SWSCALE SWRESAMPLE REQUIRED)
  if(FFMPEG_FOUND)
    target_link_libraries(CorsixTH PRIVATE ${FFMPEG_LIBRARIES})
    include_directories(${FFMPEG_INCLUDE_DIRS})
    if(APPLE)
      target_link_libraries(CorsixTH PRIVATE libz.dylib)
      # These LDFLAGS are necessary for static ffmpeg, harmless for dynamic ffmpeg
      set(CMAKE_EXE_LINKER_FLAGS "-liconv -framework CoreMedia -framework CoreVideo -framework VideoToolbox")
    endif()
    message("  FFmpeg found")
  else()
    message(FATAL_ERROR "Error: FFmpeg library not found, even though it was selected to be included")
  endif()
endif()

# Find Freetype2
if(CORSIX_TH_USE_FREETYPE2)
  if(VCPKG_TARGET_TRIPLET)
    find_package(Freetype REQUIRED)
    target_link_libraries(CorsixTH PRIVATE Freetype::Freetype)
  else()
    find_package(Freetype REQUIRED)
    if(FREETYPE_FOUND)
      target_link_libraries(CorsixTH PRIVATE ${FREETYPE_LIBRARIES})
      include_directories(${FREETYPE_INCLUDE_DIRS})
      if(APPLE)
        target_link_libraries(CorsixTH PRIVATE libz.dylib)
        target_link_libraries(CorsixTH PRIVATE libbz2.dylib)
      endif()
      message("  FreeType2 found")
    else()
      message(FATAL_ERROR "Error: FreeType2 library not found, even though it was selected to be used")
    endif()
  endif()
endif()

if(WITH_UPDATE_CHECK)
  find_package(CURL REQUIRED COMPONENTS HTTPS SSL)
  if(CURL_FOUND)
    target_link_libraries(CorsixTH PRIVATE CURL::libcurl)
    message("  Curl found")
  else()
    message(FATAL_ERROR "Error: curl not found")
  endif()
endif()

if(CORSIX_TH_LINK_LUA_MODULES)
  message("Linking lua modules")
  find_package(unofficial-luafilesystem CONFIG REQUIRED)
  target_link_libraries(CorsixTH PRIVATE unofficial::luafilesystem::lfs)

  find_package(unofficial-lpeg CONFIG REQUIRED)
  target_link_libraries(CorsixTH PRIVATE unofficial::lpeg::lpeg)

  add_custom_command(TARGET CorsixTH POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy
    ${UNOFFICIAL_LPEG_LUA_FILES}
    $<TARGET_FILE_DIR:CorsixTH>)

  if(NOT USE_SOURCE_DATADIRS)
    install(FILES ${UNOFFICIAL_LPEG_LUA_FILES} DESTINATION ${CORSIX_TH_DATADIR})
  endif()
else()
  message("Lua modules are not linked and will be loaded at runtime")
endif()

if(MSVC AND CORSIX_TH_USE_VLD)
  find_package(VLD REQUIRED)
  if(VLD_FOUND)
    target_link_libraries(CorsixTH PRIVATE ${VLD_LIBRARY})
    include_directories(CorsixTH PRIVATE ${VLD_INCLUDE_DIR})
    message("  VLD found")
  else()
    message(FATAL_ERROR "Error: VLD Library not found, it is required to build when USE_VLD is set")
  endif()
endif()

# Launch script to facilitate out of source builds
if(USE_SOURCE_DATADIRS)
  # Do not generate launch script. The default is fine for this case.
elseif(XCODE)
  message(WARNING "By default you will not be able to run CorsixTH from Xcode. If you do not plan to deploy then run cmake with -DUSE_SOURCE_DATADIRS. If you want to both run and deploy from Xcode then set the command line arguments in your run scheme to --interpreter=${CMAKE_CURRENT_SOURCE_DIR}/CorsixTH.lua")
elseif(APPLE)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/run-corsix-th-dev.sh.in.apple ${CMAKE_CURRENT_BINARY_DIR}/run-corsixth-dev.sh @ONLY)
elseif(UNIX)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/run-corsix-th-dev.sh.in ${CMAKE_CURRENT_BINARY_DIR}/run-corsixth-dev.sh @ONLY)
elseif(MSVC)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/CorsixTH.vcxproj.user.in ${CMAKE_CURRENT_BINARY_DIR}/CorsixTH.vcxproj.user @ONLY)
endif()

# Adding testing files whilst we also have the list of source files and have found libs
if(ENABLE_UNIT_TESTS)
  message("Building Unit Tests")
  # Enable testing if set at this level so we can use CTest from the root of the build dir
  enable_testing()
  add_subdirectory(${PROJECT_SOURCE_DIR}/CppTest)
endif()

# Declaration of the install process
if(NOT USE_SOURCE_DATADIRS)
  if(APPLE)
    # Just use the prefix as it's sufficient to just set the prefix to /Applications on Mac.
    install(TARGETS CorsixTH BUNDLE DESTINATION .)
  elseif(MSVC)
    install(TARGETS CorsixTH
      RUNTIME DESTINATION ${CORSIX_TH_DATADIR}
      LIBRARY DESTINATION ${CORSIX_TH_DATADIR}
      ARCHIVE DESTINATION ${CORSIX_TH_DATADIR}
    )
    install(FILES CorsixTH.ico DESTINATION ${CORSIX_TH_DATADIR})

    # Install dependencies
    file(GLOB DLL_DEPS "${CMAKE_CURRENT_BINARY_DIR}/*.dll")
    install(FILES ${DLL_DEPS} DESTINATION ${CORSIX_TH_DATADIR})
    file(GLOB LUA_DEPS "${CMAKE_CURRENT_BINARY_DIR}/*.lua")
    install(FILES ${LUA_DEPS} DESTINATION ${CORSIX_TH_DATADIR})
    if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/mime")
      install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/mime" "${CMAKE_CURRENT_BINARY_DIR}/socket" DESTINATION ${CORSIX_TH_DATADIR})
    endif()
    # Include this module to search for compiler-provided system runtime
    # libraries and add install rules for them.
    set(CMAKE_INSTALL_SYSTEM_RUNTIME_DESTINATION ".")
    include(InstallRequiredSystemLibraries)
  else()
    install(TARGETS CorsixTH
      RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
  endif()
  install(DIRECTORY Campaigns Lua Levels DESTINATION ${CORSIX_TH_DATADIR})
  install(DIRECTORY Bitmap DESTINATION ${CORSIX_TH_DATADIR}
    FILES_MATCHING REGEX ".*\\.(tab|pal|dat|png)$"
  )
  install(FILES CorsixTH.lua ../LICENSE.txt DESTINATION ${CORSIX_TH_DATADIR})

  if(UNIX AND NOT APPLE)
    install(FILES corsix-th.6 DESTINATION ${CMAKE_INSTALL_MANDIR}/man6)

=== tools/rnc/CMakeLists.txt ===
# Sanity check
if(CORSIX_TH_DONE_TOP_LEVEL_CMAKE)
else()
  message(FATAL_ERROR "Please run CMake from the top-level directory instead of here.")
endif()

# Project Declaration
project(RncDecodeCli)

add_executable(
	RncDecodeCli
	rnc_decode_cli.cpp
)

set_target_properties(RncDecodeCli PROPERTIES OUTPUT_NAME "rnc_decode")

target_link_libraries(RncDecodeCli RncLib)

# Set language standard
set_property(TARGET RncDecodeCli PROPERTY CXX_STANDARD 14)
set_property(TARGET RncDecodeCli PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET RncDecodeCli PROPERTY CXX_STANDARD_REQUIRED ON)

if(MSVC)
  # We want to bind against the very latest versions of the MSVC runtimes
  add_definitions(/D "_BIND_TO_CURRENT_VCLIBS_VERSION=1")
endif()

=== debian/changelog ===
corsix-th (0.68.0-1) unstable; urgency=medium

  * New upstream version 0.68.0
  * Change my email address

 -- Alexandre Detiste <tchet@debian.org>  Tue, 22 Oct 2024 18:23:20 +0200

=== debian/control ===
Source: corsix-th
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Alexandre Detiste <tchet@debian.org>,
 Phil Morrell <debian@emorrp1.name>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 imagemagick,
 libavcodec-dev,
 libavformat-dev,
 libfreetype-dev,
 liblua5.4-dev,
 libsdl2-dev,
 libsdl2-mixer-dev,
 libswresample-dev,
 libswscale-dev,
 lua-busted,
 lua5.4,
Standards-Version: 4.6.2
Homepage: https://corsixth.com
Vcs-Git: https://salsa.debian.org/games-team/corsix-th.git
Vcs-Browser: https://salsa.debian.org/games-team/corsix-th
Rules-Requires-Root: no

Package: corsix-th
Architecture: any
Depends:
 corsix-th-data (= ${source:Version}),
 lua-filesystem,
 lua-lpeg (>= 1.0.2-2),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 theme-hospital-data | theme-hospital-demo-data | game-data-packager,
 timidity,
Description: Open source clone of Theme Hospital
 Theme Hospital was a simulation computer game developed by Bullfrog
 Productions and published by Electronic Arts in 1997, in which the player
 designs and operates a hospital.
 .
 The game currently requires the original graphics and tries to mimic the
 original as closely as possible. Therefore you will need a copy of the
 original game for this package to be useful.

Package: corsix-th-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Open source clone of Theme Hospital (data package)
 Theme Hospital was a simulation computer game developed by Bullfrog
 Productions and published by Electronic Arts in 1997, in which the player
 designs and operates a hospital.
 .
 The game currently requires the original graphics and tries to mimic the
 original as closely as possible. Therefore you will need a copy of the
 original game for this package to be useful.
 .
 (This package contains the data files)

=== debian/watch ===
version=4
opts=uversionmangle=s/-/~/,\
s/v([^\/]+)\.tar\.gz/v$1\/CorsixTH-$1\.tar\.gz/;\
s/$/.sig/ \
 https://github.com/CorsixTH/CorsixTH/tags (?:.*/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## corsix-th 0.69.0

=== debian/changelog ===
corsix-th (0.69.0-1) unstable; urgency=medium

  * New upstream version 0.69.0
  * Switch to X-Style: black

  [ Phil Morrell ]
  * Revert "there is no GPG signature"

 -- Alexandre Detiste <tchet@debian.org>  Mon, 21 Jul 2025 22:43:58 +0200

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
  Alexandre Detiste <tchet@debian.org>,
  Phil Morrell <debian@emorrp1.name>,
 Build-Depends:
+ debhelper-compat (= 13),
  cmake,
- debhelper-compat (= 13),
  imagemagick,
  libavcodec-dev,
  libavformat-dev,
@@ -24,6 +24,7 @@
 Vcs-Git: https://salsa.debian.org/games-team/corsix-th.git
 Vcs-Browser: https://salsa.debian.org/games-team/corsix-th
 Rules-Requires-Root: no
+X-Style: black
 
 Package: corsix-th
 Architecture: any

## corsix-th 0.69.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,21 +1,28 @@
 # Cmake File for CorsixTH
 # OPTIONS AVAILABLE:
 # Any of the following: (default)
+
+# CorsixTH Features and behaviour
 #   - WITH_AUDIO      : Activate sound (yes)
 #   - WITH_FREETYPE2  : Active support for non-Latin script alphabets (yes)
+#   - WITH_FONT       : Path of a font that will be used if the user does not set one (empty, Arial on macOS)
 #   - WITH_MOVIES     : Activate movies (requires with_audio, FFmpeg) (yes)
-#   - WITH_LUAJIT     : Use LuaJIT instead of Lua (must specify library path) (no)
 #   - WITH_UPDATE_CHECK : Activates support to check for new version on launch (requires libcurl) (yes)
 #   - USE_SOURCE_DATADIRS : Use the source directory for loading resources. Incompatible with the install target (no)
 #   - SEARCH_LOCAL_DATADIRS : Search resources in the working directory and the
 #       program directory where the executable stores. Makes the executable
 #       portable (yes for Apple)
 
-#   - WITH_VLD        : Build with Visual Leak Detector (requires Visual Studio) (no)
-#   - USE_PRECOMPILED_DEPS : Use precompiled dependencies on *nix (no)
+# Dependency resolution
+#   - WITH_LUAJIT     : Use LuaJIT instead of Lua (must specify library path) (no)
 #   - WITH_LUAROCKS : Install required luarocks in the macOS app (requires luarocks)
+#   - FETCH_CATCH2: Use FetchContent to obtain Catch2 if ENABLE_UNIT_TESTS=yes
 
+# Tests and debug options
 #   - ENABLE_UNIT_TESTS : Enable Unit Testing Target (requires Catch2) (no)
+#   - ENABLE_SANITIZERS : Build with AddressSanitizer (ASan) and UndefinedBehaviorSanitizer (UBSan) enabled (no)
+
+# Additional build targets
 #   - BUILD_ANIMVIEW : Generate AnimView build files (no)
 #   - BUILD_TOOLS : Generate cli tools
 
@@ -32,6 +39,7 @@
 option(ENABLE_UNIT_TESTS "Enables Unit Testing Targets" OFF)
 option(BUILD_ANIMVIEW "Build the animation viewer as part of the build process" OFF)
 option(BUILD_TOOLS "Build additional CLI tools (rnc_decode)" OFF)
+option(ENABLE_SANITIZERS "Build with ASan and UBSan enabled" OFF)
 
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
 
@@ -56,8 +64,22 @@
 
 project(CorsixTH_Top_Level)
 
+if(ENABLE_UNIT_TESTS)
+  enable_testing()
+endif()
+
 if(MINGW)
   set(CMAKE_EXE_LINKER_FLAGS "-static-libgcc -static-libstdc++")
+endif()
+
+if(ENABLE_SANITIZERS)
+  if(MSVC)
+    # https://learn.microsoft.com/en-us/cpp/build/reference/fsanitize?view=msvc-170
+    add_compile_options(/fsanitize=address)
+  else()
+    add_compile_options(-fsanitize=address,undefined)
+    add_link_options(-fsanitize=address,undefined)
+  endif()
 endif()
 
 include(CheckIncludeFiles)
@@ -74,14 +96,16 @@
   "Search resources in the working directory and the program directory where the executable stores."
   ${SEARCH_LOCAL_DATADIRS_DEFAULT})
 
-if(MSVC)
-  option(WITH_VLD "Build with Visual Leak Detector for Visual Studio" OFF)
-endif()
-# Dependency management
-if(UNIX AND CMAKE_COMPILER_IS_GNU)
-  option(USE_PRECOMPILED_DEPS "Use Precompiled Dependencies" OFF) # Make *nix systems opt in
+if(WITH_FREETYPE2)
+  if(APPLE)
+    set(WITH_FONT_DEFAULT "/Library/Fonts/Arial Unicode.ttf")
+  else()
+    set(WITH_FONT_DEFAULT "")
+  endif()
+  set(WITH_FONT ${WITH_FONT_DEFAULT} CACHE FILEPATH "Use this font if one is not set in the game settings")
 endif()
 
+# Dependency management
 if(APPLE)
   option(WITH_LUAROCKS "Install required luarocks in the app" OFF)
 endif()
@@ -127,24 +151,6 @@
   set(CORSIX_TH_LINK_LUA_MODULES OFF)
 endif()
 
-if(MSVC)
-  if(WITH_VLD)
-    set(CORSIX_TH_USE_VLD ON)
-    message("Note: Visual Leak Detector is enabled")
-  else()
-    set(CORSIX_TH_USE_VLD OFF)
-    message("Note: Visual Leak Detector is disabled (default)")
-  endif()
-else()
-  set(CORSIX_TH_USE_VLD OFF)
-endif()
-
-# Get precompiled dependencies before running the various find modules
-if(USE_PRECOMPILED_DEPS)
-  message("Note: Using precompiled dependencies.")
-  include(PrecompiledDeps)
-endif()
-
 include(GNUInstallDirs)
 
 # Include individual projects

=== CorsixTH/CMakeLists.txt ===
--- 
+++ 
@@ -67,6 +67,11 @@
   set(CORSIX_TH_ARCH ${CMAKE_SYSTEM_PROCESSOR})
 endif()
 
+# Set default value of font file in compile_opts.font
+if(WITH_FONT)
+  set(CORSIX_TH_FONT ${WITH_FONT})
+endif()
+
 # Ensure config.h is picked up by cmake - moving this into subdir cmake files will
 # prevent it applying to the CorsixTH project
 set(CorsixTH_generated_src_dir ${CMAKE_BINARY_DIR}/CorsixTH/Src/)
@@ -116,7 +121,7 @@
       message("Make sure the path is correctly defined or set the environment variable SDLDIR to the correct location")
     endif()
     # No need to specify sdl2main separately, the FindSDL.cmake file will take care of that. If not we get an error about it
-    target_link_libraries(CorsixTH PRIVATE ${SDL_LIBRARY})
+    target_link_libraries(CorsixTH_lib PUBLIC ${SDL_LIBRARY})
     message("  SDL2 found")
   else()
     message(FATAL_ERROR "Error: SDL2 library not found, it is required to build. Make sure the path is correctly defined or set the environment variable SDLDIR to the correct location")
@@ -127,11 +132,10 @@
 if(VCPKG_TARGET_TRIPLET)
   find_package(Lua CONFIG REQUIRED)
   target_link_libraries(CorsixTH_lib PUBLIC lua)
-  target_link_libraries(CorsixTH PRIVATE lua)
 else()
   find_package(Lua REQUIRED)
   if(Lua_FOUND OR LUA_FOUND)
-    target_link_libraries(CorsixTH PUBLIC ${LUA_LIBRARY})
+    target_link_libraries(CorsixTH_lib PUBLIC ${LUA_LIBRARY})
     include_directories(${LUA_INCLUDE_DIR})
     # Special link flags needed on macOS 64bit, according to: http://luajit.org/install.html
     # If these are not specified, luaL_newstate() returns NULL and we get this:
@@ -162,13 +166,13 @@
   if(VCPKG_TARGET_TRIPLET)
     find_package(SDL2_mixer CONFIG REQUIRED)
     target_link_libraries(
-      CorsixTH
-      PRIVATE
+      CorsixTH_lib
+      PUBLIC
         $<IF:$<TARGET_EXISTS:SDL2_mixer::SDL2_mixer>,SDL2_mixer::SDL2_mixer,SDL2_mixer::SDL2_mixer-static>)
   else()
     find_package(SDL2_mixer REQUIRED)
     if(SDLMIXER_FOUND)
-      target_link_libraries(CorsixTH PRIVATE ${SDLMIXER_LIBRARY})
+      target_link_libraries(CorsixTH_lib PUBLIC ${SDLMIXER_LIBRARY})
       include_directories(${SDLMIXER_INCLUDE_DIR})
       message("  SDL_mixer found")
     else()
@@ -181,7 +185,7 @@
 if(CORSIX_TH_USE_FFMPEG)
   find_package(FFmpeg COMPONENTS AVFORMAT AVCODEC AVUTIL SWSCALE SWRESAMPLE REQUIRED)
   if(FFMPEG_FOUND)
-    target_link_libraries(CorsixTH PRIVATE ${FFMPEG_LIBRARIES})
+    target_link_libraries(CorsixTH_lib PUBLIC ${FFMPEG_LIBRARIES})
     include_directories(${FFMPEG_INCLUDE_DIRS})
     if(APPLE)
       target_link_libraries(CorsixTH PRIVATE libz.dylib)
@@ -198,15 +202,15 @@
 if(CORSIX_TH_USE_FREETYPE2)
   if(VCPKG_TARGET_TRIPLET)
     find_package(Freetype REQUIRED)
-    target_link_libraries(CorsixTH PRIVATE Freetype::Freetype)
+    target_link_libraries(CorsixTH_lib PUBLIC Freetype::Freetype)
   else()
     find_package(Freetype REQUIRED)
     if(FREETYPE_FOUND)
-      target_link_libraries(CorsixTH PRIVATE ${FREETYPE_LIBRARIES})
+      target_link_libraries(CorsixTH_lib PUBLIC ${FREETYPE_LIBRARIES})
       include_directories(${FREETYPE_INCLUDE_DIRS})
       if(APPLE)
-        target_link_libraries(CorsixTH PRIVATE libz.dylib)
-        target_link_libraries(CorsixTH PRIVATE libbz2.dylib)
+        target_link_libraries(CorsixTH_lib PRIVATE libz.dylib)
+        target_link_libraries(CorsixTH_lib PRIVATE libbz2.dylib)
       endif()
       message("  FreeType2 found")
     else()
@@ -218,7 +222,7 @@
 if(WITH_UPDATE_CHECK)
   find_package(CURL REQUIRED COMPONENTS HTTPS SSL)
   if(CURL_FOUND)
-    target_link_libraries(CorsixTH PRIVATE CURL::libcurl)
+    target_link_libraries(CorsixTH_lib PRIVATE CURL::libcurl)
     message("  Curl found")
   else()
     message(FATAL_ERROR "Error: curl not found")
@@ -228,10 +232,10 @@
 if(CORSIX_TH_LINK_LUA_MODULES)
   message("Linking lua modules")
   find_package(unofficial-luafilesystem CONFIG REQUIRED)
-  target_link_libraries(CorsixTH PRIVATE unofficial::luafilesystem::lfs)
+  target_link_libraries(CorsixTH_lib PRIVATE unofficial::luafilesystem::lfs)
 
   find_package(unofficial-lpeg CONFIG REQUIRED)
-  target_link_libraries(CorsixTH PRIVATE unofficial::lpeg::lpeg)
+  target_link_libraries(CorsixTH_lib PRIVATE unofficial::lpeg::lpeg)
 
   add_custom_command(TARGET CorsixTH POST_BUILD
     COMMAND ${CMAKE_COMMAND} -E copy
@@ -243,17 +247,6 @@
   endif()
 else()
   message("Lua modules are not linked and will be loaded at runtime")
-endif()
-
-if(MSVC AND CORSIX_TH_USE_VLD)
-  find_package(VLD REQUIRED)
-  if(VLD_FOUND)
-    target_link_libraries(CorsixTH PRIVATE ${VLD_LIBRARY})
-    include_directories(CorsixTH PRIVATE ${VLD_INCLUDE_DIR})
-    message("  VLD found")
-  else()
-    message(FATAL_ERROR "Error: VLD Library not found, it is required to build when USE_VLD is set")
-  endif()
 endif()
 
 # Launch script to facilitate out of source builds
@@ -273,7 +266,6 @@
 if(ENABLE_UNIT_TESTS)
   message("Building Unit Tests")
   # Enable testing if set at this level so we can use CTest from the root of the build dir
-  enable_testing()
   add_subdirectory(${PROJECT_SOURCE_DIR}/CppTest)
 endif()
 
@@ -317,3 +309,5 @@
 
   if(UNIX AND NOT APPLE)
     install(FILES corsix-th.6 DESTINATION ${CMAKE_INSTALL_MANDIR}/man6)
+    install(FILES com.corsixth.corsixth.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)
+    install(FILES com.corsixth.corsixth.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

=== libs/CMakeLists.txt ===
add_subdirectory(rnc)

if(SEARCH_LOCAL_DATADIRS)
  add_subdirectory(whereami)
endif()

=== tools/CMakeLists.txt ===
add_subdirectory(rnc)

=== CorsixTH/CppTest/CMakeLists.txt ===
# MIT License
#
# Copyright (c) 2019 David Fairbrother
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

if(FETCH_CATCH2)
  include(FetchContent)

  fetchcontent_declare(
    Catch2
    GIT_REPOSITORY https://github.com/catchorg/Catch2.git
    GIT_TAG        v3.8.1
  )

  fetchcontent_makeavailable(Catch2)
else()
  find_package(Catch2 3 CONFIG REQUIRED)
endif()

add_custom_target(AllTests)

add_executable(UnitTests "")
target_link_libraries(UnitTests
  Catch2::Catch2WithMain
  CorsixTH_lib)

set_property(TARGET UnitTests PROPERTY CXX_STANDARD 14)
set_property(TARGET UnitTests PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET UnitTests PROPERTY CXX_STANDARD_REQUIRED ON)

# Add the target to CTest
set_target_properties(UnitTests PROPERTIES FOLDER UnitTests)

# Make sure we add it as a dependency to all tests (some day we can add LuaTest here)
add_dependencies(AllTests UnitTests)

# List of all test files
target_sources(UnitTests
    PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/test_th_lua.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_th_lua_map.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/test_th_strings.cpp
)

include(CTest)
include(Catch)
catch_discover_tests(UnitTests)

=== CorsixTH/Src/CMakeLists.txt ===
# Modify the config.h based upon our selection of options
configure_file(${CMAKE_SOURCE_DIR}/CorsixTH/Src/config.h.in ${CMAKE_BINARY_DIR}/CorsixTH/Src/config.h)

target_sources(CorsixTH_lib
    PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/random.c
    ${CMAKE_CURRENT_SOURCE_DIR}/bootstrap.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/iso_fs.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/lua_rnc.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/persist_lua.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/run_length_encoder.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/sdl_audio.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/sdl_core.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/sdl_wm.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_gfx.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_gfx_font.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_gfx_sdl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_lua.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_lua_anims.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_lua_gfx.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_lua_iso.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_lua_lfs_ext.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_lua_map.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_lua_movie.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_lua_sound.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_lua_strings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_lua_ui.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_map.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_map_overlays.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_movie.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_pathfind.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_sound.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/th_strings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/xmi2mid.cpp
)

# These are for IDEs such as XCode and MSVC to track headers within their
# project files. They are not used by the build system.
target_sources(CorsixTH_lib
    PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/bootstrap.h
    ${CMAKE_CURRENT_SOURCE_DIR}/cp437_table.h
    ${CMAKE_CURRENT_SOURCE_DIR}/cp936_table.h
    ${CMAKE_CURRENT_SOURCE_DIR}/iso_fs.h
    ${CMAKE_CURRENT_SOURCE_DIR}/lua_rnc.h
    ${CMAKE_CURRENT_SOURCE_DIR}/lua_sdl.h
    ${CMAKE_CURRENT_SOURCE_DIR}/persist_lua.h
    ${CMAKE_CURRENT_SOURCE_DIR}/run_length_encoder.h
    ${CMAKE_CURRENT_SOURCE_DIR}/th.h
    ${CMAKE_CURRENT_SOURCE_DIR}/th_gfx.h
    ${CMAKE_CURRENT_SOURCE_DIR}/th_gfx_font.h
    ${CMAKE_CURRENT_SOURCE_DIR}/th_gfx_sdl.h
    ${CMAKE_CURRENT_SOURCE_DIR}/th_lua.h
    ${CMAKE_CURRENT_SOURCE_DIR}/th_lua_internal.h
    ${CMAKE_CURRENT_SOURCE_DIR}/th_map.h
    ${CMAKE_CURRENT_SOURCE_DIR}/th_map_overlays.h
    ${CMAKE_CURRENT_SOURCE_DIR}/th_movie.h
    ${CMAKE_CURRENT_SOURCE_DIR}/th_pathfind.h
    ${CMAKE_CURRENT_SOURCE_DIR}/th_sound.h
    ${CMAKE_CURRENT_SOURCE_DIR}/th_strings.h
    ${CMAKE_CURRENT_SOURCE_DIR}/xmi2mid.h

    ${CMAKE_BINARY_DIR}/CorsixTH/Src/config.h
)

target_sources(CorsixTH
    PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main.h
)

=== CorsixTH/SrcUnshared/CMakeLists.txt ===
target_sources(CorsixTH
    PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
)

=== libs/whereami/CMakeLists.txt ===
project(WhereamiLib)

add_library(WhereamiLib)
target_include_directories(WhereamiLib PRIVATE ".")

target_sources(WhereamiLib PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/whereami.c
  ${CMAKE_CURRENT_SOURCE_DIR}/whereami.h
)

=== debian/changelog ===
corsix-th (0.69.1-1) unstable; urgency=medium

  * New upstream version 0.69.1

 -- Alexandre Detiste <tchet@debian.org>  Sun, 24 Aug 2025 19:36:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: corsix-th
 Section: contrib/games
-Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Alexandre Detiste <tchet@debian.org>,
@@ -19,11 +18,10 @@
  libswscale-dev,
  lua-busted,
  lua5.4,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://corsixth.com
 Vcs-Git: https://salsa.debian.org/games-team/corsix-th.git
 Vcs-Browser: https://salsa.debian.org/games-team/corsix-th
-Rules-Requires-Root: no
 X-Style: black
 
 Package: corsix-th

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_BINDIR=/usr/games/ -DCMAKE_INSTALL_DATADIR=/usr/share/games/ -DWITH_UPDATE_CHECK=no

execute_after_dh_auto_install:
	rm -v debian/tmp/usr/share/games/corsix-th/LICENSE.txt

	for size in $$(identify ico:CorsixTH/CorsixTH.ico | awk '{print $$3}'); \
	do \
		mkdir -vp debian/corsix-th/usr/share/icons/hicolor/$$size/apps/ ; \
	done
	convert -verbose ico:CorsixTH/CorsixTH.ico -set filename:size %wx%h \
		debian/corsix-th/usr/share/icons/hicolor/%[filename:size]/apps/corsix-th.png

execute_after_dh_auto_test:
	busted -C CorsixTH/Luatest --verbose
